package chatapp.Model;

import java.io.Serializable;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * <p>
 * Classe representant les messages envoyes en TCP lors d'une session de clavardage.
 * Un message Horodate est compose d'un destintaire, d'une source , d'un message et d'une date d'envoie.
 * </p>
 */
public class MessageHorodate implements Serializable {
    private Utilisateur destinataire ;
    private Utilisateur source ;
    private Date dateHorodatage ;
    private int type; // 0 = debut de la communication, 1= message de communication, 2 = fin de la communicataion
    private String Message;

    /**
     * <p>
     * Constructeur , le message va etre horodate
     * @param destinataire - Destinataire du message
     * @param source - Source du message
     * @param Message - Message envoye
     * </p>
     */
    public MessageHorodate(Utilisateur destinataire, Utilisateur source, String Message, int type) {
        this.setDestinataire(destinataire) ;
        this.setSource(source) ;
        this.setMessage(Message) ;
        this.setDateHorodatage(new Date());
        this.type = type;
    }

    /**
     * Setter: Date d'horodatage
     * On modifie le date d'horodatage
     */
    public void setDate(Date d) {
        this.setDateHorodatage(d);
    }

    /**
     * <p>
     * Permet de creer une representation string du message
     * @return Les differents attributs de la classe sous forme de string
     * </p>
     */
    @Override
    public String toString() {
        String Msg = "";
        Msg += ("Destinataire::" + this.getDestinataire() + "\n") ;
        Msg += ("Source::" + this.getSource()+ "\n") ;
        Msg += ("Type::"+ this.type+ "\n");
        Msg += ("Date::" + this.dateToString() + "\n") ;
        Msg += ("Message::" + this.getMessage() + "\n" );
        return Msg ;
    }

    /**
     * <p>
     * Permet de creer une representation string de la date d'horodatage
     * @return La date d'horodatage du message en format yyyy/MM/dd HH:mm:ss
     * </p>
     */
    public String dateToString() {
        DateFormat format = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
        return format.format(this.getDateHorodatage());
    }


    /**
     * <p>
     * Permet de re creer un message horodate a partir d'un string
     * @return un messageHorodate
     * </p>
     */
    public static MessageHorodate stringToMessageHorodate(String s) {
        String[] mots = s.split("\n");
        Utilisateur destinataire = Utilisateur.stringToUtilisateur(mots[0].split("::")[1]);
        Utilisateur source = Utilisateur.stringToUtilisateur(mots[1].split("::")[1]);
        int type = Integer.parseInt(mots[2].split("::")[1]);
        String payload = "";
        for(int i=4; i< mots.length; i++) {
            if(mots[i].startsWith("Message::")) {
                mots[i]=mots[i].split("::")[1];
            }
            payload += mots[i]+"\n";
        }
        return new MessageHorodate(destinataire, source, payload, type);
    }

    /**
     * Getter: Utilisateur Source
     * @return Utilisateur a l'origine du message
     */
    public Utilisateur getSource() {
        return source;
    }

    /**
     * Setter: Utilisateur Source
     * On modifie l'utilisateur source
     */
    public void setSource(Utilisateur source) {
        this.source = source;
    }

    /**
     * Getter: Utilisateur Destinataire
     * @return Utilisateur recevant le message
     */
    public Utilisateur getDestinataire() {
        return destinataire;
    }

    /**
     * Setter: Utilisateur Destinataire
     * On modifie l'utilisateur Destinataire
     */
    public void setDestinataire(Utilisateur destinataire) {
        this.destinataire = destinataire;
    }

    /**
     * Getter: Message envoye
     * @return Le message envoye
     */
    public String getMessage() {
        return Message;
    }

    /**
     * Setter: Message envoye
     * On modifie le message envoye
     */
    public void setMessage(String message) {
        Message = message;
    }

    /**
     * Getter: 'Type' du message
     * @return On recupere le Type du message
     */
    public int getType() {
        return type;
    }
    /**
     * Setter: 'Type' du message horodate
     * On modifie l'integer 'Type'
     */
    public void setType(int Type) {
        this.type = type;
    }

    /**
     * Getter: Date d'horodatage
     * @return On recupere le date
     */
    public Date getDateHorodatage() {
        return dateHorodatage;
    }

    /**
     * Setter: Date d'horodatage
     * On modifie le date.
     */
    public void setDateHorodatage(Date dateHorodatage) {
        this.dateHorodatage = dateHorodatage;
    }

}
